"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helper_1 = require("../helper");
class Color {
    constructor(name, r, g, b, a) {
        this.name = name.replace(/\s+/g, "-").toUpperCase();
        this.rFloat = r;
        this.gFloat = g;
        this.bFloat = b;
        this.aFloat = a;
    }
    get formatedName() {
        return this.name;
    }
    get HEX() {
        if (this.rgbaIsValid()) {
            return helper_1.rgbToHex(this.rFloat, this.gFloat, this.bFloat);
        }
    }
    get RGBA() {
        if (this.rgbaIsValid()) {
            return helper_1.rgbaToString(this.rFloat, this.gFloat, this.bFloat, this.aFloat);
        }
    }
    get CssColor() {
        const color = this.aFloat < 1 ? this.RGBA : this.HEX;
        return `$${this.name}: ${color};`;
    }
    get JSONColor() {
        const color = this.aFloat < 1 ? this.RGBA : this.HEX;
        const name = this.name.replace(/-/g, "_");
        return `export const ${name} = '${color}';`;
    }
    rgbaIsValid() {
        if (!(this.rFloat || this.gFloat || this.bFloat || this.aFloat)) {
            return false;
        }
        return true;
    }
}
exports.default = Color;
//# sourceMappingURL=color.js.map