"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Typography {
    constructor(name, fFamily, fWeight, fSize, lSpacing, lHeight) {
        this.name = name.replace(/\s+/g, "-").toUpperCase();
        this.fontFamily = fFamily;
        this.fontWeight = fWeight;
        this.fontSize = fSize;
        this.letterSpacing = lSpacing;
        this.lineHeight = lHeight;
    }
    get formatedName() {
        return this.name;
    }
    get CSSFontFamily() {
        const handler = `${this.name}-FONT-FAMILY`;
        const fontFamily = this.fontFamilyAddon(this.fontFamily, "scss");
        return `$${handler}: ${fontFamily};`;
    }
    get CSSFontWeight() {
        const handler = `${this.name}-FONT-WEIGHT`;
        return `$${handler}: ${this.fontWeight};`;
    }
    get CSSFontSize() {
        const handler = `${this.name}-FONT-SIZE`;
        return `$${handler}: ${this.fontSize.toFixed(2)}px;`;
    }
    get CSSLetterSpacing() {
        const handler = `${this.name}-LETTER-SPACING`;
        return `$${handler}: ${this.letterSpacing.toFixed(2)}px;`;
    }
    get CSSLineHeight() {
        const handler = `${this.name}-LINE-HEIGHT`;
        return `$${handler}: ${this.lineHeight.toFixed(2)}px;`;
    }
    get JSONFontFamily() {
        const name = this.name.replace(/-/g, "_");
        const fontFamily = this.fontFamilyAddon(`'${this.fontFamily}'`, "js");
        const handler = `${name}_FONT_FAMILY`;
        return `export const ${handler} = "${fontFamily}";`;
    }
    get JSONFontWeight() {
        const name = this.name.replace(/-/g, "_");
        const handler = `${name}_FONT_WEIGHT`;
        return `export const ${handler} = '${this.fontWeight}';`;
    }
    get JSONFontSize() {
        const name = this.name.replace(/-/g, "_");
        const handler = `${name}_FONT_SIZE`;
        return `export const ${handler} = '${this.fontSize.toFixed(2)}px';`;
    }
    get JSONLetterSpacing() {
        const name = this.name.replace(/-/g, "_");
        const handler = `${name}_LETTER_SPACING`;
        return `export const ${handler} = '${this.letterSpacing.toFixed(2)}px';`;
    }
    get JSONLineHeight() {
        const name = this.name.replace(/-/g, "_");
        const handler = `${name}_LINE_HEIGHT`;
        return `export const ${handler} = '${this.lineHeight.toFixed(2)}px';`;
    }
    fontFamilyAddon(fontFamily, format) {
        return format === "js"
            ? // tslint:disable-next-line:max-line-length
                `${fontFamily},-apple-system,BlinkMacSystemFont,Segoe UI,Helvetica,Arial,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol`
            : // tslint:disable-next-line:max-line-length
                `'${fontFamily}',-apple-system,BlinkMacSystemFont,Segoe UI,Helvetica,Arial,sans-serif,Apple Color Emoji,Segoe UI Emoji,Segoe UI Symbol`;
    }
}
exports.default = Typography;
//# sourceMappingURL=typography.js.map